diff admin/charsets/mapconv @ 88123:375f2633d815

New directory
author Kenichi Handa <handa@m17n.org>
date Mon, 08 Sep 2003 11:56:09 +0000
parents
children a750cf193ec6
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/admin/charsets/mapconv	Mon Sep 08 11:56:09 2003 +0000
@@ -0,0 +1,125 @@
+#!/bin/sh
+#
+# Copyright (C) 2003
+#   National Institute of Advanced Industrial Science and Technology (AIST)
+#   Registration Number H13PRO009
+#
+# This file is part of GNU Emacs.
+#
+# GNU Emacs is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Emacs is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GNU Emacs; see the file COPYING.  If not, write to the
+# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Comment:
+# Convert charset map of various format into this:
+#	0xXX 0xYYYY
+# where,
+#   XX is a code point of the charset in hexa-decimal,
+#   YYYY is the corresponding Unicode character code in hexa-decimal.
+# Arguments are:
+#   $1: source map file
+#   $2: address pattern for sed (optionally with substitution command)
+#   $3: format of source map file
+#	GLIBC-1 GLIBC-2 GLIBC-2-7 CZYBORRA IANA UNICODE YASUOKA MICROSOFT
+#   $4: awk script
+
+BASE=`basename $1`
+
+case "$3" in
+    GLIBC*)
+	SOURCE=`echo $1 | sed 's/.*\(glibc.*$\)/\1/'`;;
+    CZYBORRA)
+	SOURCE="http://czyborra.com/charsets/${BASE}";;
+    IANA)
+	SOURCE="http://www.iana.org/assignments/charset-reg/${BASE}";;
+    UNICODE)
+	SOURCE="http://www.unicode.org/Public/MAPPINGS/.../${BASE}";;
+    YASUOKA)
+	SOURCE="http://kanji.zinbun.kyoto-u.ac.jp/~yasuoka/.../${BASE}";;
+    MICROSOFT)
+	SOURCE="http://www.microsoft.com/globaldev/reference/oem/${BASE}";;
+    *)
+	echo "Unknown file type: $3";
+	exit 1;;
+esac
+
+echo "# Generated from $SOURCE"
+
+if [ -n "$4" ] ; then
+    if [ -f "$4" ] ; then
+	AWKPROG="gawk -f $4"
+    else
+	echo "Awk program does not exist: $4"
+	exit 1
+    fi
+else
+    AWKPROG=cat
+fi
+
+if [ "$3" == "GLIBC-1" ] ; then
+    # Source format is:
+    #   <UYYYY>	/xXX
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's,<U\([^>]*\)>[ 	]*/x\(..\).*,0x\2 0x\1,' \
+	| sort | ${AWKPROG}
+elif [ "$3" == "GLIBC-2" ] ; then
+    # Source format is:
+    #   <UYYYY>	/xXX/xZZ
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's,<U\([^>]*\)>[ 	]*/x\(..\)/x\(..\).*,0x\2\3 0x\1,' \
+	| sort | ${AWKPROG}
+elif [ "$3" == "GLIBC-2-7" ] ; then
+    # Source format is:
+    #   <UYYYY>	/xXX/xZZ
+    # We must drop MSBs of XX and ZZ
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's/xa/x2/g' -e 's/xb/x3/g' -e 's/xc/x4/g' \
+	      -e 's/xd/x5/g' -e 's/xe/x6/g' -e 's/xf/x7/g' \
+	      -e 's,<U\([^>]*\)>[ 	]*/x\(..\)/x\(..\).*,0x\2\3 0x\1,' \
+	| tee temp \
+	| sort | ${AWKPROG}
+elif [ "$3" == "CZYBORRA" ] ; then
+    # Source format is:
+    #   =XX	U+YYYY
+    zcat $1 | sed -n -e "$2 p" \
+	| sed -e 's/=\(..\)[^U]*U+\([0-9A-F]*\).*/0x\1 0x\2/' \
+	| sort | ${AWKPROG}
+elif [ "$3" == "IANA" ] ; then
+    # Source format is:
+    #   0xXX	0xYYYY
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's/\(0x[0-9A-Fa-f]*\)[^0]*\(0x[0-9A-Fa-f]*\).*/\1 \2/' \
+	| sort | ${AWKPROG}
+elif [ "$3" == "UNICODE" ] ; then
+    # Source format is:
+    #   YYYY	XX
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's/\([0-9A-F]*\)[^0-9A-F]*\([0-9A-F]*\).*/0x\2 0x\1/' \
+	| sort | ${AWKPROG}
+elif [ "$3" == "YASUOKA" ] ; then
+    # Source format is:
+    # YYYY	0-XXXX (XXXX is a Kuten code)
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's/\([0-9A-F]*\)[^0]*0-\([0-9]*\).*/0x\2 0x\1/' \
+	| sort | ${AWKPROG}
+elif [ "$3" == "MICROSOFT" ] ; then
+    # Source format is:
+    # XX = U+YYYY
+    sed -n -e "$2 p" < $1 \
+	| sed -e 's/\([0-9A-F]*\).*U+\([0-9A-F]*\).*/0x\1 0x\2/' \
+	| sort | ${AWKPROG}
+else
+    echo "Invalid arguments"
+    exit 1
+fi